Scriptname idek:uss:USSResetScript extends Quest

WorkshopParentScript Property WorkshopParent	Auto Const Mandatory

Quest Property _USSQuest						Auto Const Mandatory
Quest Property _USSHolotapeQuest				Auto Const Mandatory
Quest Property _USSReset						Auto Const Mandatory
Quest Property _USSTempAttackDisableQuest		Auto Const Mandatory

GlobalVariable Property _USSDebugMode			Auto Const Mandatory

Message Property _USSResetSuccess				Auto Const Mandatory
Message Property _USSResetFail					Auto Const Mandatory

; StartQuest/StopQuest as console commands have been known not to handle aliases properly.
Event OnQuestInit()
	ResetUSS()
EndEvent

Function ResetUSS()
	bool debugMode = _USSDebugMode.GetValue() as bool
	
	if (debugMode)
		Debug.TraceUser("UncappedSettlementSurplus", "Reset script triggered. Stopping quests...")
	endif
	
	_USSQuest.Stop()
	_USSHolotapeQuest.Stop()
	_USSTempAttackDisableQuest.Stop()
	
	if (debugMode)
		Debug.TraceUser("UncappedSettlementSurplus", "Quests stopped.")
	endif
	
	Utility.wait(0.5) ; the waits probably aren't necessary, but won't hurt
	
	; One time, while testing, USS auto-reset precisely in the middle of an update, and didn't ever put DailyUpdateInProgress back to false
	; This caused all settlements to stop working until I realized what was wrong and fixed it with a console command
	; This might cause minor, temporary bugs on rare occasions, but that is preferable to breaking all settlements
	WorkshopParent.DailyUpdateInProgress = false

	; This causes things to break horribly, apparently resetting does -not- work with quest aliases
	;	_USSQuest.Reset()
	;	_USSHolotapeQuest.Reset()
	;	Utility.wait(0.5)
	
	if (debugMode)
		Debug.TraceUser("UncappedSettlementSurplus", "Restarting quests...")
	endif
	
	_USSQuest.Start()
	_USSHolotapeQuest.Start()
	
	Utility.wait(0.5)
	
	; Disables attacks until the start of the next daily update cycle
	_USSTempAttackDisableQuest.Start()
	
	Utility.Wait(0.5)
		
	if (_USSQuest.GetCurrentStageID() == 0)
		if (debugMode)
			Debug.TraceUser("UncappedSettlementSurplus", "All quests successfully restarted.")
		endif
		
		_USSResetSuccess.Show()
	else
		if (debugMode)
			Debug.TraceUser("UncappedSettlementSurplus", "All quests restarted, but USSQuest appears to have failed to start? That's not good.")
		endif
		
		_USSResetFail.Show()
	endif
	
	_USSReset.Stop()
EndFunction
